> For the complete documentation index, see [llms.txt](https://docs.postgresql.tw/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.postgresql.tw/15/reference/sql-commands/alter-operator.md).

# ALTER OPERATOR

## ALTER OPERATOR

ALTER OPERATOR — change the definition of an operator

### Synopsis

```

ALTER OPERATOR name ( { left_type | NONE } , right_type )
    OWNER TO { new_owner | CURRENT_ROLE | CURRENT_USER | SESSION_USER }

ALTER OPERATOR name ( { left_type | NONE } , right_type )
    SET SCHEMA new_schema

ALTER OPERATOR name ( { left_type | NONE } , right_type )
    SET ( {  RESTRICT = { res_proc | NONE }
           | JOIN = { join_proc | NONE }
         } [, ... ] )
```

### Description

`ALTER OPERATOR` changes the definition of an operator.

You must own the operator to use `ALTER OPERATOR`. To alter the owner, you must also be a direct or indirect member of the new owning role, and that role must have `CREATE` privilege on the operator's schema. (These restrictions enforce that altering the owner doesn't do anything you couldn't do by dropping and recreating the operator. However, a superuser can alter ownership of any operator anyway.)

### Parameters

*`name`*

The name (optionally schema-qualified) of an existing operator.

*`left_type`*

The data type of the operator's left operand; write `NONE` if the operator has no left operand.

*`right_type`*

The data type of the operator's right operand.

*`new_owner`*

The new owner of the operator.

*`new_schema`*

The new schema for the operator.

*`res_proc`*

The restriction selectivity estimator function for this operator; write NONE to remove existing selectivity estimator.

*`join_proc`*

The join selectivity estimator function for this operator; write NONE to remove existing selectivity estimator.

### Examples

Change the owner of a custom operator `a @@ b` for type `text`:

```

ALTER OPERATOR @@ (text, text) OWNER TO joe;
```

Change the restriction and join selectivity estimator functions of a custom operator `a && b` for type `int[]`:

```

ALTER OPERATOR && (_int4, _int4) SET (RESTRICT = _int_contsel, JOIN = _int_contjoinsel);
```

### Compatibility

There is no `ALTER OPERATOR` statement in the SQL standard.

### See Also

[CREATE OPERATOR](/15/reference/sql-commands/create-operator.md), [DROP OPERATOR](/15/reference/sql-commands/drop-operator.md)

***

原文：[PostgreSQL 15.19 Documentation](/15/reference/sql-commands/alter-operator.md)（英文原文，待翻譯）


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.postgresql.tw/15/reference/sql-commands/alter-operator.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
